/*
 * Copyright (C) 2024 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.nachrichten.postfach.muk.transfer;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.TestPropertySource;

import de.ozgcloud.common.test.ITCase;
import de.ozgcloud.nachrichten.postfach.muk.MukPostfachProperties;
import de.ozgcloud.nachrichten.postfach.muk.MukPostfachRemoteService;
import de.ozgcloud.nachrichten.postfach.muk.MukPostfachTestConfiguration;

@SpringBootTest(
  classes = { MukPostfachTestConfiguration.class, MukPostfachRemoteService.class, ElsterTransferRemoteService.class,
	ElsterTransferConfiguration.class, ElsterRestClient.class, MukPostfachProperties.class })
@TestPropertySource(properties = { "ozgcloud.muk.server=localhost", "ozgcloud.muk.user-name=user",
  "ozgcloud.muk.password=123456789" })
@ITCase
@Disabled("Für Tests gegen einer 'echten' ELSTER-Transfer Instanz. Wie z.B. eines lokal laufenden Elster-Transfer Containers.")
public class E4kMukPostfachLoadRepliesITCase {
	static final String URL = "http://localhost:32159";

	@Autowired
	private ElsterTransferRemoteService elsterTransferService;

	@Autowired
	private MukPostfachProperties properties;

	@BeforeEach
	void setUp() {
		properties.setServer(URL);
	}

	@Nested
	class TestLoadingReplies {
		@Test
		void shouldLoadAntworten() {
			var messages = elsterTransferService.loadAntworten();

			assertThat(messages).isNotNull();
		}
	}
}
